
#define     _DEG_AS_mm (60000u)        /*   1 degree, 60 minutes */
#define  _90_DEG_AS_mm (60000Lu *  90) /*  90 degrees */
#define _180_DEG_AS_mm (60000Lu * 180) /* 180 degrees */

/* in ordinates, north/east are positive */

#define negative_hemisphere(dw) (*(byte *) &(dw) & 0x80)

struct coord {
	long lat, lon; /* signed milliminutes */
};

struct vector {
	struct coord coord;
	word course, knots;
};

struct area {
	word radius;
	struct coord *center; /* to fixed center location or to 'gps' etc */
};

struct wallclock {
	byte
		year, month, day,
		hour, minute, second;
};

struct abbrclock {
	byte
		month, day,
		hour, minute; /* must have same layout as wallclock */
};

extern struct wallclock wallclock;
extern struct abbrclock abbrclock; /* overlapping wallclock */

void wallclock_reset(void); /* call before presetting wallclock */
void wallclock_run(void);   /* second accumulation overflows ~ twice a day */

extern short gps_satellites;

void sted_gps_altitude(long meters);

