
#include "standard.h"
#include "hamdr_cfg.h"

#define putc SCI_putc
#define puts SCI_puts

#define TERM (cfg.term_type - 1)

#define ESC "\033"
#define CSI ESC "["
#define ARG1 "\0"    /* where to put argument in */

static struct tcap {
	int  row1_off;   /* from internal 1...ttylines to row index */
	char *cm_col1;   /* cursor motion, column 1 */
	char *ce;        /* clear to end of line */
	char *cd;        /* clear to end of screen */
} tcap[] = {
	{  0, CSI ARG1 "H",        CSI "K",   CSI "J", }, /* 1: ansi */
	{ -1, ESC "&a" ARG1 "y0C", ESC "K",   ESC "J", }, /* 2: 2: hp */
};

static void
putu(word u)
{
	if (u >= 10) {
		putu(u / 10);
		u %= 10;
	}
	putc('0' + u);
}

static void
put1(char *seq, word arg)
{
	puts(seq);         /* before \0 */
	putu(arg);
	while (*seq++)     /* zoom past \0 */
		;
	puts(seq);         /* after \0 */
}

void
ttrow(word row)
{
	struct tcap *t;

	if (TERM >= __SIZEOF(tcap))
		return;

	t = &tcap[TERM];
	put1(t->cm_col1, row + t->row1_off);
	puts(t->ce);
}

void
ttclear()
{
	if (TERM >= __SIZEOF(tcap))
		return;

	puts(tcap[TERM].cd);
}

