
	section	.data
	align	1
_veclogger
	dc.w	_veclog
	align	1
_speedlogger
	dc.w	_speedlog

	global	_temperature_lowest
	align	1
_temperature_lowest
	dc.w	32767

	global	_temperature_highest
	align	1
_temperature_highest
	dc.w	-32768

	section	.text
	align	1

	global	_thermometer_hilo
_thermometer_hilo
	pshm	z
	tsz

	lde	#32767
	ste	_temperature_lowest
	lde	#-32768
	ste	_temperature_highest
	pulm	z
	rts

	align	1

	global	_thermometer
_thermometer
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	cpe	_temperature_lowest
	bge	L3
	
	ste	_temperature_lowest
	asre
	ste	_temperature_celsius_lo
	lde	0,z
	jsr	_half_c_to_fahrenheit
	tde	
	ste	_temperature_fahrenheit_lo

L3	ldd	0,z
	cpd	_temperature_highest
	ble	L4
	
	std	_temperature_highest
	lde	0,z
	asre
	ste	_temperature_celsius_hi
	lde	0,z
	jsr	_half_c_to_fahrenheit
	tde	
	ste	_temperature_fahrenheit_hi

L4	ldab	#1
	stab	_have_thermometer

	ais	#+2
	pulm	z
	rts

	align	1

	global	_windgust
_windgust
	pshm	z
	tsz

	clrd	
	ldy	#_speedlog

L6	cpd	0,y
	bhs	L8
	
	ldd	0,y

L8	xgdy	
	addd	#2
	xgdy	
	cpy	#_speedlog+60
	blo	L6
	
	pulm	z
	rts

	align	1

	global	_windspeed
_windspeed
	pshm	z
	ais	#-2
	tsz

	clre	
	ldy	_speedlogger
	ldab	#6
	stab	0,z

L12	xgdy	
	addd	#-2
	xgdy	
	cpy	#_speedlog
	bhs	L15
	
	ldy	#_speedlog+58

L15	adde	0,y
	dec	0,z
	bne	L12
	
	ldx	#6
	ted	
	idiv	
	txd	

	ais	#+2
	pulm	z
	rts

	align	1

	global	_winddir
_winddir
	pshm	z
	ais	#-12
	tsz

	clrw	4,z
	clrw	6,z
	clrw	8,z
	clrw	10,z
	ldy	#_veclog

L18	ldd	2+4,z
	addd	2+0,y
	std	2+4,z
	ldd	0+4,z
	adcb	1+0,y
	adca	0+0,y
	std	0+4,z
	ldd	2+8,z
	addd	2+4,y
	std	2+8,z
	ldd	0+8,z
	adcb	1+4,y
	adca	0+4,y
	std	0+8,z
	xgdy	
	addd	#8
	xgdy	
	cpy	#_veclog+48
	blo	L18
	
	ldx	8,z
	stx	0,z
	ldx	10,z
	stx	2,z
	lde	4,z
	ldd	6,z
	jsr	_iatan2

	ais	#+12
	pulm	z
	rts

	align	1
_jorgio
	pshm	z
	ais	#-16
	tsz

	std	4,z
	bne	L23
	
	ldd	#1
	std	4,z

L23	clr	6,z
	cpe	#179
	bls	L25
	
	ldab	#1
	stab	6,z

L25	tst	6,z
	beq	L24
	
	aie	#-180

L24	jsr	_eight_bit_sin_from_abs_degrees
	lde	4,z
	jsr	_EMUL
	ste	0,z
	tzy	
	std	2,y
	tst	6,z
	beq	L26
	
	tye	
	jsr	_lnegate

L26	ldd	0,z
	std	12,z
	ldd	2,z
	std	14,z
	lde	12,z
	ldd	14,z

	ais	#+16
	pulm	z
	rts

	align	1
_log_wind_sample
	pshm	z
	ais	#-12
	tsz

	ste	0,z
	std	2,z
	jsr	_jorgio
	ste	4,z
	std	6,z
	ldd	0,z
	aid	#90
	std	0,z
	cpd	#359
	bls	L28
	
	aid	#-360
	std	0,z

L28	lde	0,z
	ldd	2,z
	jsr	_jorgio
	ste	8,z
	std	10,z
	jsr	_hold_txproc
	ldy	_veclogger
	ldd	4,z
	std	0,y
	ldd	6,z
	std	2,y
	ldd	8,z
	std	4,y
	ldd	10,z
	std	6,y
	xgdy	
	addd	#8
	xgdy	
	sty	_veclogger
	cpy	#_veclog+48
	blo	L29
	
	ldd	#_veclog
	std	_veclogger

L29	ldy	_speedlogger
	ldd	18,z
	std	0,y
	lde	_speedlogger
	aie	#2
	ste	_speedlogger
	cpe	#_speedlog+60
	blo	L30
	
	ldd	#_speedlog
	std	_speedlogger

L30	jsr	_okay_txproc

	ais	#+12
	pulm	z
	rts


	section	.bss
Lmark.16
	ds.b	4
Lold.17
	ds.b	4

	section	.text
	align	1
_anemometer
	pshm	z
	ais	#-18
	tsz

	ste	4,z
	tze	
	jsr	_read_pulsacc
	ste	10,z
	std	12,z
	ldd	2+10,z
	subd	2+Lold.17
	std	2+6,z
	ldd	0+10,z
	sbcb	1+Lold.17
	sbca	0+Lold.17
	std	0+6,z
	ldd	2+6,z
	addd	2+Lold.17
	std	2+14,z
	ldd	0+6,z
	adcb	1+Lold.17
	adca	0+Lold.17
	std	0+14,z
	ldy	14,z
	sty	Lold.17
	ldx	16,z
	stx	Lold.17+2
	tstw	6,z
	bls	L32
	
	clrw	6,z
	ldy	#65535
	sty	8,z

L32	ldy	8,z
	ldx	4,z
	sty	0,x
	ldd	2+0,z
	subd	2+Lmark.16
	std	2+6,z
	ldd	0+0,z
	sbcb	1+Lmark.16
	sbca	0+Lmark.16
	std	0+6,z
	ldx	0,z
	stx	Lmark.16
	ldy	2,z
	sty	Lmark.16+2
	tstw	6,z
	bls	L34
	
	clrw	6,z
	clrw	8,z

L34	ldd	8,z

	ais	#+18
	pulm	z
	rts


	section	.data
	align	1
_vane_to_deg
	dc.w	0
	dc.w	6
	dc.w	17
	dc.w	11
	dc.w	39
	dc.w	34
	dc.w	23
	dc.w	28
	dc.w	84
	dc.w	79
	dc.w	68
	dc.w	73
	dc.w	45
	dc.w	51
	dc.w	62
	dc.w	56
	dc.w	174
	dc.w	169
	dc.w	158
	dc.w	163
	dc.w	135
	dc.w	141
	dc.w	152
	dc.w	146
	dc.w	90
	dc.w	96
	dc.w	107
	dc.w	101
	dc.w	129
	dc.w	124
	dc.w	113
	dc.w	118
	dc.w	354
	dc.w	349
	dc.w	338
	dc.w	343
	dc.w	315
	dc.w	321
	dc.w	332
	dc.w	326
	dc.w	270
	dc.w	276
	dc.w	287
	dc.w	281
	dc.w	309
	dc.w	304
	dc.w	293
	dc.w	298
	dc.w	180
	dc.w	186
	dc.w	197
	dc.w	191
	dc.w	219
	dc.w	214
	dc.w	203
	dc.w	208
	dc.w	264
	dc.w	259
	dc.w	248
	dc.w	253
	dc.w	225
	dc.w	231
	dc.w	242
	dc.w	236

	section	.bss
Llog.20
	ds.b	360
Li.21
	ds.b	2

	section	.text
	align	1

	global	_log_rain_gauge
_log_rain_gauge
	pshm	z
	ais	#-2
	tsz

	tex	
	adde	_rainfall_today
	ste	_rainfall_today
	cpx	#255
	bls	L37
	
	ldx	#255

L37	ldy	Li.21
	xgdy	
	addd	#Llog.20
	xgdy	
	ldab	0,y
	clra	
	std	0,z
	txd	
	stab	0,y
	xgdx	
	subd	0,z
	xgdx	
	txe	
	adde	_rainfall_1hr
	ste	_rainfall_1hr
	lde	Li.21
	aie	#1
	ste	Li.21
	cpe	#360
	bne	L38
	
	clrw	Li.21

L38	ldab	#1
	stab	_have_rain_gauge

	ais	#+2
	pulm	z
	rts

	align	1

	global	_rain_gauge_centi_inch
_rain_gauge_centi_inch
	pshm	z
	ais	#-2
	tsz

	ldy	_cfg+1312
	sty	0,z
	ldd	#100
	jsr	_muldiv

	ais	#+2
	pulm	z
	rts


	section	.data

LC0	dc.b	077h,078h,020h,020h,000h

	align	1	; ASM_OUTPUT_ASCII

LC1	dc.b	0B0h,020h,020h,000h

	align	1	; ASM_OUTPUT_ASCII

LC2	dc.b	020h,06Bh,06Dh,02Fh,068h,000h

	align	1	; ASM_OUTPUT_ASCII

LC3	dc.b	020h,020h,000h

	align	1	; ASM_OUTPUT_ASCII

LC4	dc.b	02Fh,000h

	align	1	; ASM_OUTPUT_ASCII

LC5	dc.b	0B0h,043h,000h

	align	1	; ASM_OUTPUT_ASCII

LC6	dc.b	025h,000h

	align	1	; ASM_OUTPUT_ASCII

LC7	dc.b	068h,050h,061h,000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1
_weather_station
	pshm	z
	ais	#-8
	tsz

	tze	
	aie	#2
	jsr	_anemometer
	tdy	
	cpy	#0
	lbeq	L40
	
	tstw	2,z
	beq	L42
	
	lde	2,z
	ldx	_cfg+842
	sty	0,z
	txd	
	jsr	_muldiv
	tde	
	ldx	#10
	idiv	
	stx	4,z
	ldab	#1
	stab	_have_anemometer
	bra	L43
	

L42	clrw	4,z

L43	jsr	_windvane
	tde	
	asle	
	tey	
	xgdy	
	addd	#_vane_to_deg
	xgdy	
	lde	0,y
	tey	
	xgdy	
	addd	_cfg+968
	xgdy	
	lde	#360
	tyd	
	tex	
	idiv	
	std	6,z
	ldy	2,z
	ldd	4,z
	std	0,z
	lde	6,z
	tyd	
	jsr	_log_wind_sample
	tst	_cfg+970
	lbeq	L40
	
	lde	#LC0
	jsr	_print_string
	lde	6,z
	jsr	_print_short
	lde	#LC1
	jsr	_print_string
	lde	4,z
	jsr	_miles_to_km
	tde	
	jsr	_print_short
	lde	#LC2
	jsr	_print_string
	tst	_have_thermometer
	beq	L45
	
	lde	#LC3
	jsr	_print_string
	lde	_temperature_celsius_lo
	jsr	_print_signed_short
	lde	_temperature_celsius_lo
	cpe	_temperature_celsius_hi
	beq	L46
	
	lde	#LC4
	jsr	_print_string
	lde	_temperature_celsius_hi
	jsr	_print_signed_short

L46	lde	#LC5
	jsr	_print_string

L45	tst	_have_hygrometer
	beq	L47
	
	lde	#LC3
	jsr	_print_string
	lde	_relative_humidity
	jsr	_print_short
	lde	#LC6
	jsr	_print_string

L47	tst	_have_barometer
	beq	L48
	
	lde	#LC3
	jsr	_print_string
	lde	_barometric_pressure
	jsr	_print_short
	lde	#LC7
	jsr	_print_string

L48	jsr	_eol

L40
	ais	#+8
	pulm	z
	rts

	align	1
_hih3610_relhum
	pshm	z
	ais	#-6
	tsz

	ste	4,z
	tdy	
	cpy	#-50
	bge	L50
	
	ldy	#-50
	bra	L51
	

L50	cpy	#100
	ble	L51
	
	ldy	#100

L51	lde	4,z
	cpe	#10485
	bls	L53
	
	aie	#-10486
	ste	4,z
	bra	L54
	

L53	clrw	4,z

L54	tyd	
	lde	#70
	emuls	
	std	2,z
	ldy	#-30979
	xgey	
	sde	
	xgey	
	sty	0,z
	lde	4,z
	ldd	#16129
	jsr	_muldiv
	std	4,z
	lde	4,z
	aie	#100
	ste	4,z
	ldy	#200
	tyx	
	ldd	4,z
	idiv	
	txy	
	cpy	#100
	bls	L55
	
	ldy	#100

L55	tyd	

	ais	#+6
	pulm	z
	rts

	align	1
_hih3610_round
	pshm	z
	tsz

	tst	_have_thermometer
	beq	L57
	
	lde	#7
	jsr	_read_AN
	tde	
	tste	
	beq	L57
	
	ldd	_temperature_celsius_lo
	jsr	_hih3610_relhum
	tde	
	ste	_relative_humidity
	ldab	#1
	stab	_have_hygrometer

L57	pulm	z
	rts

	align	1
_lm75_round
	pshm	z
	ais	#-4
	tsz

	tzd	
	aid	#2
	ldy	#2
	sty	0,z
	lde	#144
	jsr	_i2c_rd
	tstb	
	beq	L60
	
	lde	2,z
	jsr	_thermometer

L60
	ais	#+4
	pulm	z
	rts


	section	.data
LAccess_Config.34
	dc.b	172
LRead_Temperature.35
	dc.b	170
LStart_Convert_T.36
	dc.b	238
Lhappy.37
	dc.b	0

	section	.text
	align	1

	global	_ds1621_round
_ds1621_round
	pshm	z
	ais	#-8
	tsz

	tst	Lhappy.37
	beq	L62
	
	ldd	#1
	std	0,z
	lde	#-32610
	ldd	#LRead_Temperature.35
	jsr	_i2c_wr
	stab	6,z
	beq	L62
	
	tzy	
	xgdy	
	addd	#2
	xgdy	
	ldd	#2
	std	0,z
	lde	#158
	tyd	
	jsr	_i2c_rd
	stab	6,z
	beq	L62
	
	lde	2,z
	asre
	asre
	asre
	asre
	asre
	asre
	asre
	jsr	_thermometer
	jmp	L61
	

L62	clr	Lhappy.37
	ldd	#1
	std	0,z
	lde	#-32610
	ldd	#LAccess_Config.34
	jsr	_i2c_wr
	stab	6,z
	lbeq	L61
	
	tzy	
	xgdy	
	addd	#4
	xgdy	
	ldd	#1
	std	0,z
	lde	#158
	tyd	
	jsr	_i2c_rd
	stab	6,z
	lbeq	L61
	
	ldab	4,z
	andb	#12
	cmpb	#12
	bne	L65
	
	ldab	#81
	stab	LStart_Convert_T.36

L65	ldab	4,z
	andb	#1
	beq	L66
	
	bclr	4,z,#254^0FFh
	ldd	#1
	std	0,z
	lde	#-32610
	ldd	#LAccess_Config.34
	jsr	_i2c_wr
	stab	6,z
	beq	L61
	
	tzy	
	xgdy	
	addd	#4
	xgdy	
	ldd	#1
	std	0,z
	clre	
	tyd	
	jsr	_i2c_wr
	stab	6,z
	beq	L61
	

L66	ldd	#1
	std	0,z
	lde	#158
	ldd	#LStart_Convert_T.36
	jsr	_i2c_wr
	stab	6,z
	beq	L61
	
	ldab	#1
	stab	Lhappy.37

L61
	ais	#+8
	pulm	z
	rts

	align	1
_winddir_cse
	pshm	z
	tsz

	jsr	_winddir
	tstd	
	bne	L71
	
	ldd	#360

L71	pulm	z
	rts

	align	1
_windspeed_spd
	pshm	z
	tsz

	jsr	_windspeed
	pulm	z
	rts


	section	.data

LC8	dc.b	02Eh,02Eh,02Eh,02Fh,02Eh,02Eh,02Eh,067h
	dc.b	02Eh,02Eh,02Eh,000h

	align	1	; ASM_OUTPUT_ASCII

LC9	dc.b	02Eh,02Eh,02Eh,000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1

	global	_encode_weather_ascii
_encode_weather_ascii
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	tst	_have_anemometer
	beq	L74
	
	jsr	_winddir_cse
	tdx	
	lde	0,z
	jsr	_sprint_03u
	std	0,z
	ldab	#47
	ldy	0,z
	stab	0,y
	incw	0,z
	jsr	_windspeed_spd
	tdx	
	lde	0,z
	jsr	_sprint_03u
	std	0,z
	ldab	#103
	ldy	0,z
	stab	0,y
	incw	0,z
	jsr	_windgust
	tdx	
	lde	0,z
	jsr	_sprint_03u
	bra	L81
	

L74	lde	0,z
	ldd	#LC8
	jsr	_strcpyx

L81	std	0,z
	ldab	#116
	ldy	0,z
	stab	0,y
	incw	0,z
	tst	_have_thermometer
	beq	L76
	
	lde	0,z
	ldd	_temperature_fahrenheit_lo
	jsr	_sprint_03d_signed
	bra	L77
	

L76	lde	0,z
	ldd	#LC9
	jsr	_strcpyx

L77	ldy	0,z
	xgdy	
	addd	#3
	xgdy	
	sty	0,z
	tst	_have_hygrometer
	beq	L78
	
	lde	0,z
	ldd	_relative_humidity
	jsr	_sprint_03u
	ldab	#104
	ldy	0,z
	stab	0,y
	xgdy	
	addd	#3
	xgdy	
	sty	0,z

L78	tst	_have_barometer
	beq	L79
	
	ldab	#98
	ldy	0,z
	stab	0,y
	incw	0,z
	lde	0,z
	ldd	_barometric_pressure
	jsr	_sprint_u
	std	0,z
	ldab	#48
	ldy	0,z
	stab	0,y
	incw	0,z

L79	tst	_have_rain_gauge
	beq	L80
	
	ldab	#114
	ldy	0,z
	stab	0,y
	incw	0,z
	lde	_rainfall_1hr
	jsr	_rain_gauge_centi_inch
	tdx	
	lde	0,z
	jsr	_sprint_03u
	std	0,z

L80	ldd	0,z

	ais	#+2
	pulm	z
	rts


	section	.data
	align	1
Lmatch.46
	dc.w	_ow_round
	dc.w	_sht1x_round
	dc.w	_lm75_round
	dc.w	_ds1621_round
	dc.w	_hih3610_round
	dc.w	_weather_station
	dc.w	0
	align	1
Lgame.47
	dc.w	Lmatch.46

	section	.bss
Lmark.48
	ds.b	4

	section	.text
	align	1

	global	_weather_run
_weather_run
	pshm	z
	tsz

	ldy	Lgame.47
	tstw	0,y
	beq	L83
	
	ldd	0,y
	tye	
	aie	#2
	ste	Lgame.47
	clre	
	jsr	_fncall
	bra	L84
	

L83	lde	Lmark.48
	ldd	Lmark.48+2
	jsr	_time_past
	tstb	
	beq	L84
	
	ldx	#Lmatch.46
	stx	Lgame.47
	jsr	_thermometer_hilo
	lde	#Lmark.48
	ldd	#10000
	jsr	_future_msec

L84	pulm	z
	rts

	align	1

	global	_sensors_timeout
_sensors_timeout
	pshm	z
	tsz

	tst	_have_anemometer
	beq	L87
	
	inc	_have_anemometer

L87	tst	_have_barometer
	beq	L88
	
	inc	_have_barometer

L88	tst	_have_hygrometer
	beq	L89
	
	inc	_have_hygrometer

L89	tst	_have_thermometer
	beq	L90
	
	inc	_have_thermometer

L90	pulm	z
	rts

	align	1

	global	_wx_midnight
_wx_midnight
	pshm	z
	tsz

	clrw	_rainfall_today
	pulm	z
	rts


	section	.bss

	global	_have_thermometer
_have_thermometer
	ds.b	1

	global	_have_hygrometer
_have_hygrometer
	ds.b	1

	global	_have_anemometer
_have_anemometer
	ds.b	1

	global	_have_barometer
_have_barometer
	ds.b	1

	global	_have_rain_gauge
_have_rain_gauge
	ds.b	1

	global	_have_a_nice_day
_have_a_nice_day
	ds.b	1

	global	_temperature_celsius_hi
_temperature_celsius_hi
	ds.b	2

	global	_temperature_celsius_lo
_temperature_celsius_lo
	ds.b	2

	global	_temperature_fahrenheit_hi
_temperature_fahrenheit_hi
	ds.b	2

	global	_temperature_fahrenheit_lo
_temperature_fahrenheit_lo
	ds.b	2

	global	_relative_humidity
_relative_humidity
	ds.b	2

	global	_rainfall_1hr
_rainfall_1hr
	ds.b	2

	global	_rainfall_today
_rainfall_today
	ds.b	2

	global	_barometric_pressure
_barometric_pressure
	ds.b	2

	global	_wind_direction
_wind_direction
	ds.b	2

	global	_wind_knots
_wind_knots
	ds.b	2

	global	_wind_gust
_wind_gust
	ds.b	2
_veclog
	ds.b	48
_speedlog
	ds.b	60


	end
