/*
 * Copyright (c) 1985, 1986 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ax_var.h	0.0 (Skinnarila) 10/19/93
 */

/*
 * Interface address, AX25 version.  One of these structures
 * is allocated for each interface with an AX25 address.
 * The ifaddr structure contains the protocol-independent part
 * of the structure and is assumed to be first.
 */
struct ax_ifaddr {
	struct	ifaddr aa_ifa;				/* protocol-independent info */
#define	aa_ifp		aa_ifa.ifa_ifp
#define aa_flags	aa_ifa.ifa_flags
	struct	ax_addr aa_netbroadcast;	/* to recognize net broadcasts */
	struct	ax_ifaddr *aa_next;			/* next in list of internet addresses */
	struct	sockaddr_ax aa_addr;		/* reserve space for interface name */
	struct	sockaddr_ax aa_dstaddr;		/* reserve space for broadcast addr */
#define	aa_broadaddr	aa_dstaddr
};

struct	ax_aliasreq {
	char	ifra_name[IFNAMSIZ];		/* if name, e.g. "ax0" */
	struct	sockaddr_ax ifra_addr;
	struct	sockaddr_ax ifra_broadaddr;
#define ifra_dstaddr ifra_broadaddr
};
/*
 * Given a pointer to an ax_ifaddr (ifaddr),
 * return a pointer to the addr as a sockaddr_ax.
 */
#define	AA_SAX(aa) (&(((struct ax_ifaddr *)(aa))->aa_addr))

struct axstat {
	u_long axs_total;
	u_long axs_toosmall;
	u_long axs_notours;
	u_long axs_unimpl;
	u_long axs_noproto;
	u_long axs_oldproto;
	u_long axs_delivered;
	u_long axs_closed;
	u_long axs_drops;
	u_long axs_nobufs;
	u_long axs_connattempt;
	u_long axs_rffu0;
	u_long axs_rffu1;
	u_long axs_rffu2;
	u_long axs_rffu3;
	u_long axs_rffu4;
	u_long axs_rffu5;
	u_long axs_rffu6;
	u_long axs_rffu7;
	u_long axs_rffu8;
	u_long axs_rffu9;
	u_long axs_rffua;
	u_long axs_rffub;
	u_long axs_rffuc;
	u_long axs_rffud;
	u_long axs_rffue;
	u_long axs_rffuf;
};

#ifdef	KERNEL
extern struct	ax_ifaddr *ax_ifaddr;
extern struct	ax_ifaddr *ax_ifawithaddr();
extern struct	ax_ifaddr *ax_ifawithssid();
extern struct	ax_ifaddr *ax_ifawithifname();
extern struct	ifqueue	axintrq;
extern struct	axstat axstat;
extern struct	ax_addr ax_broadcastaddr;
extern int	ax_debug;
#endif
