
	section .text
	align 1

;-----------------------------------------------------------
	global _unpack_bcd_to_ascii

_unpack_bcd_to_ascii

	tsx
	ldx  4,x ; number of ascii digits
	beq  L1  ; should not happen

	xgex     ; X src in packed bcd, E digit count
	xgdy     ; Y dst in asciz
L2
	ldaa 0,x
	aix  #+1
	tab
	lsra
	lsra
	lsra
	lsra
	adda # 30h
	staa 0,y

	andb # 0Fh
	addb # 30h
	stab 1,y

	aiy  #+2
	sube #2
	bhi  L2  ; no carry, no zero
L1
	rts


;-----------------------------------------------------------
	global _repack_bcd_to_binary

_repack_bcd_to_binary

	xgex            ; buffer
	xgdy            ; byte count
L3
	ldaa 0,x        ; bcd              ---- 23--     ---- 99--
	tab             ;                  ???? 2323     ???? 9999
	andd # 0FF0h    ; ones and tens    ???? 0320     ???? 0990
	tde             ; save in E MSByte 0320 0320     0990 0990
	lsrb            ; nice             0320 0310     0990 0948
	tba             ;  shortcut        0320 1010     0990 4848
	lsrb            ;  for /= 16       0320 1008     0990 4824
	lsrb            ;  and *= 10       0320 1004     0990 4812
	aba             ; tens in binary   0320 1404     0990 5A12
	ade             ; merge with ones  1724 1404     63A2 5A12
	ted             ;                  1724 1724     63A2 63A2
	staa 0,x        ; binary           ---- 17--     ---- 63--

	aix  #+1
	aiy  #-1
	bne  L3
	rts

;-----------------------------------------------------------
	global _unpack_bcd_le

_unpack_bcd_le         ; dword unpack_bcd_le(byte *bcd, word nbytes)
	pshm z
	ais  #-6           ; dword acc at 0,z; word tmp at 4,z
	tsz

	xgex               ; byte *bcd
	adx                ; start from bcd msdigit
	xgdy               ; word nbytes

	clrw 2,z
	clrw 0,z
L4
	aix  #-1
	ldab 0,x
	lsrb
	lsrb
	lsrb
	lsrb
	bsr  dig
	ldab 0,x
	bsr  dig
	aiy  #-1           ; while --nbytes
	bne  L4

	ldd  2,z
	lde  0,z
	ais  #+6
	pulm z
	rts

dig
	andd # 0Fh
	std  4,z           ; tmp 0 ... 9

	ldd  2,z
	lde  0,z           ; *dst
	asld
	role               ; 2 times
	asld
	role               ; 4 times
	addd 2,z
	adce 0,z           ; 5 times
	asld
	role               ; 10 times
	addd 4,z
	adce # 0           ; += tmp
	std  2,z
	ste  0,z           ; *dst
	rts

