;
;  Sundry space hoggers here, to conserve the precious RAM.
;
;  2.4.2006 another round with the altitude logarithms

	section .rodata   ;----------------------------------------
	align 1

	; could skip the first few values

powers
	dc.w 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2
	dc.w 3, 3, 3, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6, 7, 7, 8
	dc.w 9, 9, 10, 11, 12, 13, 14, 15, 16, 17, 19
	dc.w 20, 22, 23, 25, 27, 30, 32, 34, 37, 40, 43, 47
	dc.w 51, 55, 59, 64, 69, 74, 80, 87, 94
	dc.w 101, 109, 118, 128, 138, 149, 161, 174, 187
	dc.w 202, 219, 236, 255, 275, 297, 321, 347, 375
	dc.w 405, 437, 472, 510, 550, 595, 642, 693, 749, 809, 874, 943
	dc.w 1019
	dc.w 65535 ; sentinel

	section .text2
	align 1

log1_08
	pshm k

	tpd
	tbxk
	ldx  # powers - 2
L1
	aix  #+2
	cpe  0,x
	bhi  L1                 ; until exact or past

	xgdx
	subd # powers           ; remove base
	lsrd                    ; offset to index

	pulm k
	rts

	global _compressed_knots
	global _compressed_range

_compressed_range           ; (word kilometers_in_E)

	ldd  # 40722            ; scale to miles, will not overflow.
	emul                    ; ED = E * D, E nicely stays in place
	rold                    ; silly facism with rounding
	adce # 0
	lsre                    ; halve it, log of twomiles
	bra  log1_08            ; take log

_compressed_knots           ; (word knots_in_E)

	adde # 1                ; add one. assume input never 65535 knots
	bra  log1_08            ; take log

	section .rodata   ;----------------------------------------
	align 1

eight_bit_sin_from_abs_degrees
	dc.b   0,  4,  8, 13, 17, 22, 26, 31, 35, 40
	dc.b  44, 48, 53, 57, 61, 66, 70, 74, 79, 83
	dc.b  87, 91, 95,100,104,108,112,116,120,124
	dc.b 127,131,135,139,143,146,150,154,157,161
	dc.b 164,167,171,174,177,181,184,187,190,193
	dc.b 196,198,201,204,207,209,212,214,217,219
	dc.b 221,223,226,228,230,232,233,235,237,238
	dc.b 240,242,243,244,246,247,248,249,250,251
	dc.b 252,252,253,254,254,255,255,255,255,255
	dc.b 255,255,255,255,255,255,254,254,253,252
	dc.b 252,251,250,249,248,247,246,244,243,242
	dc.b 240,238,237,235,233,232,230,228,226,223
	dc.b 221,219,217,214,212,209,207,204,201,198
	dc.b 196,193,190,187,184,181,177,174,171,167
	dc.b 164,161,157,154,150,146,143,139,135,131
	dc.b 127,124,120,116,112,108,104,100, 95, 91
	dc.b  87, 83, 79, 74, 70, 66, 61, 57, 53, 48
	dc.b  44, 40, 35, 31, 26, 22, 17, 13,  8,  4
	dc.b   0

	global _helptext
	align 1

	TAB = 009h
	NL  = 00Ah
_helptext
	dc.b NL
	dc.b 'nop',               TAB,'nothing',                         NL
	dc.b 'version',           TAB,'software version',                NL
	dc.b 'reboot',            TAB,'warm reboot',                     NL
	dc.b 'restart',           TAB,'less than a reboot',              NL
	dc.b 'profile n',         TAB,'select profile number n',         NL
	dc.b 'copy_profile m',    TAB,'preset current profile from m',   NL
	dc.b 'boot_profile n',    TAB,'use profile n at reboot',         NL
	dc.b 'factorydefaults',   TAB,'reset parameters',                NL
	dc.b 'perm',              TAB,'save them, current profile,',     NL
	dc.b                      TAB,'changes are temporary otherwise', NL
	dc.b 'send packet',       TAB,'send TAPR-format packet once, now',        NL
	dc.b 'telemetry payload', TAB,'add payload to be transmitted repeatedly', NL
	dc.b 'telemetry',         TAB,'stop transmitting it',            NL
	dc.b 'sendnow',           TAB,'force tracker to transmit',       NL
	dc.b 'channel n',         TAB,'show channel n (or all)',         NL
	dc.b 'channel n r',       TAB,'channel n is simplex at r kHz',   NL
	dc.b 'channel n r t',     TAB,'channel n is duplex r/t',         NL
	dc.b 'remote call',       TAB,'configure another set via radio', NL
	dc.b 'disp',              TAB,'parameters, current personality', NL
	dc.b 'disp tkdvsx',       TAB,'parameter subset',                NL
	dc.b 'disp pattern',      TAB,'parameters which match pattern',  NL
	dc.b 'stat',              TAB,'some input status',               NL
	dc.b 'help foo',          TAB,'describe parameter foo',          NL
	dc.b 'foo',               TAB,'show parameter foo',              NL
	dc.b 'foo bar',           TAB,'set parameter foo to "bar"',      NL
	dc.b 'set foo',           TAB,'clear parameter foo',             NL
	dc.b NL
	dc.b 0

	section .text2
	align 1

lookup
	pshm k

	tpd
	tbxk
	ldab e,x
	clra                 ; zeroextend for word return

	pulm k
	rts

	global _read_rodata
	global _eight_bit_sin_from_abs_degrees

_read_rodata                          ; (word offset_in_E)

	ldx  # 0
	bra  lookup

_eight_bit_sin_from_abs_degrees       ; (word absdeg_in_E)

	ldx  # eight_bit_sin_from_abs_degrees
	bra  lookup

	section .rodata   ;----------------------------------------

SYMBOL	MACRO	c, n

	dc.b c
	dc.b n
	dc.b 0

	ENDM

	; name length must be 13 or less

aprs_symbols

	SYMBOL 021h, 'police'
	SYMBOL '#','digi'
	SYMBOL '$','phone'
	SYMBOL 027h,'aircraft'
	SYMBOL 027h,'aeroplane'
	SYMBOL '*','snowmobile'
	SYMBOL '+','redcross'
	SYMBOL '-','house'
	SYMBOL '.','x'
	SYMBOL '/','dot'
	SYMBOL '0','0'
	SYMBOL '1','1
	SYMBOL '2','2'
	SYMBOL '3','3'
	SYMBOL '4','4'
	SYMBOL '5','5'
	SYMBOL '6','6'
	SYMBOL '7','7'
	SYMBOL '8','8'
	SYMBOL '9','9'
	SYMBOL ':','fire'
	SYMBOL 03Bh, 'camp'
	SYMBOL '<','motorcycle'
	SYMBOL '<','bike'
	SYMBOL '>','car'
	SYMBOL 'A','aid'
	SYMBOL 'E','eye'
	SYMBOL 'H','hotel'
	SYMBOL 'K','school'
	SYMBOL 'O','balloon'
	SYMBOL 'P','police'
	SYMBOL 'R','rv'
	SYMBOL 'U','bus'
	SYMBOL 'X','helicopter'
	SYMBOL 'Y','yacht'
	SYMBOL '[','jogger'
	SYMBOL 05Ch, 'triangle'
	SYMBOL '_','wx'
	SYMBOL 'a','ambulance'
	SYMBOL 'b','bicycle'
	SYMBOL 'd','garage'
	SYMBOL 'd','firedep'
	SYMBOL 'f','firetruck'
	SYMBOL 'g','glider'
	SYMBOL 'h','hospital'
	SYMBOL 'j','jeep'
	SYMBOL 'k','truck'
	SYMBOL 'n','node'
	SYMBOL 'o','emergencyop'
	SYMBOL 'o','eoc'
	SYMBOL 'p','rover'
	SYMBOL 'p','puppy'
	SYMBOL 'r','antenna'
	SYMBOL 's','ship'
	SYMBOL 's','powerboat'
	SYMBOL 't','truckstop'
	SYMBOL 'u','truck'
	SYMBOL 'v','van'
	SYMBOL 'w','water'
	SYMBOL 'y','yagi'

aprs_alternate_symbols

	SYMBOL '!','emergency'
	SYMBOL '#','greendigi'
	SYMBOL 027h, 'crash'
	SYMBOL '+','church'
	SYMBOL '-','hfhouse'
	SYMBOL '9','gas'
	SYMBOL 03Bh, 'picnic'
	SYMBOL '?','info'
	SYMBOL 'A','box'
	SYMBOL 'L','lighthouse'
	SYMBOL 'N','navigation'
	SYMBOL 'P','parking'
	SYMBOL 'R','restaurant'
	SYMBOL 'X','pharmacy'

aprs_symbols_end

	section .text2
	align 1

	global _next_aprs_symbol

_next_aprs_symbol          ; (word offset_in_E, byte *buf_in_D)

	pshm k

	xgdy                   ; IY to result buffer (buf[16] is ok)

	tpd
	tbxk
	ldx  # aprs_symbols
	aex                    ; IX to current offset at codelist

	clrd                   ; assume no more
	cpx  # aprs_symbols_end
	bcc  L5                ; no more

	ldab # '/'             ; assume still in primary
	cpx  # aprs_alternate_symbols
	bcs  L3
	ldab # 5Ch             ; prepend \ instead
L3
	stab 0, y              ; table id
	aiy  #+1
	clre
	ldab e, x
	stab e, y              ; symbol code
L4
	adde #+1
	ldab e, x
	stab e, y              ; one more character
	bne  L4                ; until at \0

	adde #+1               ; index over \0 to next code
	aex                    ; pointer to next code - will not overflow bank
	xgdx                   ; return value always in D
	subd # aprs_symbols    ; turn pointer into next offset
L5
	pulm k
	rts

	section .data  ; --- _DATA_, NOT rodata, such small tables --------------
	align 1

symbols_overlayable
	dc.b '#&0>AW^_acinsuvz'
	dc.b 0
mobiles_primary
	dc.b 27h                               ; '
	dc.b '<=>()*0COPRSUXY[^abefgjkpsuv'
	dc.b 0
mobiles_secondary
	dc.b '/0>AKOS^knsuv'
	dc.b 0

	section .text2
	align 1

	global _is_valid_symbol
	global _is_valid_symbol_with_compression
	global _is_mobile_symbol

_is_valid_symbol

	xgde                        ; B from tab_in_E
	cmpb # '/'
	beq  test_normal_symbol
	cmpb # 5Ch
	beq  test_normal_symbol

	cmpb # '0'
	bcs  not_valid
	cmpb # '9'
	bls  sym_scan_overlayable
	cmpb # 'A'
	bcs  not_valid
	cmpb # 'Z'
	bls  sym_scan_overlayable
	bra  not_valid

_is_valid_symbol_with_compression

	xgde
	cmpb # '/'
	beq  test_normal_symbol
	cmpb # 5Ch
	beq  test_normal_symbol

	cmpb # 'A'
	bcs  not_valid
	cmpb # 'Z'
	bls  sym_scan_overlayable
	cmpb # 'a'
	bcs  not_valid
	cmpb # 'j'
	bls  sym_scan_overlayable
not_valid
	clrd
	rts                         ; D zero if invalid

_is_mobile_symbol

	xgde                     ; tab into D
	ldx  # mobiles_primary
	cmpb # '/'
	beq  sym_scan
	ldx  # mobiles_secondary
	cmpb # 5Ch
	beq  sym_scan
	bra  not_valid           ; return FALSE


test_normal_symbol

	xgde                        ; symbol_code_in_D back
	cmpb # '!'
	bcs  not_valid
	cmpb # '~'
	bhi  not_valid
is_valid
	rts                         ; D nonzero (sym returned back)

sym_scan_overlayable
	ldx  # symbols_overlayable
sym_scan
	xgde                        ; symbol_code_in_D back
sym_scan_1
	ldaa 0,x
	beq  not_valid
	aix  #+1
	cba
	bne  sym_scan_1
	rts                         ; found, return nonzero



	section .rodata   ;----------------------------------------
	align 1

altitab
	dc.w     0 ;    0 ; meters for codes 0 ... 6144, step 128
	dc.w     0 ;  128
	dc.w     1 ;  256
	dc.w     1 ;  384
	dc.w     1 ;  512
	dc.w     1 ;  640
	dc.w     1 ;  768
	dc.w     2 ;  896
	dc.w     2 ; 1024
	dc.w     3 ; 1152
	dc.w     4 ; 1280
	dc.w     5 ; 1408
	dc.w     7 ; 1536
	dc.w     8 ; 1664
	dc.w    11 ; 1792
	dc.w    14 ; 1920
	dc.w    18 ; 2048
	dc.w    24 ; 2176
	dc.w    30 ; 2304
	dc.w    39 ; 2432
	dc.w    51 ; 2560
	dc.w    66 ; 2688
	dc.w    85 ; 2816
	dc.w   109 ; 2944
	dc.w   141 ; 3072
	dc.w   182 ; 3200
	dc.w   235 ; 3328
	dc.w   304 ; 3456
	dc.w   393 ; 3584
	dc.w   507 ; 3712
	dc.w   655 ; 3840
	dc.w   846 ; 3968
	dc.w  1092 ; 4096
	dc.w  1410 ; 4224
	dc.w  1821 ; 4352
	dc.w  2352 ; 4480
	dc.w  3037 ; 4608
	dc.w  3922 ; 4736
	dc.w  5065 ; 4864
	dc.w  6542 ; 4992
	dc.w  8448 ; 5120
	dc.w 10910 ; 5248
	dc.w 14089 ; 5376
	dc.w 18195 ; 5504
	dc.w 23498 ; 5632
	dc.w 30345 ; 5760
	dc.w 39189 ; 5888
	dc.w 50609 ; 6016 ; max error about here, 470 meters
	dc.w 65358 ; 6144
	dc.w 65535 ; XXX handle last few meters below 64k
	; dc.w 84404 ; 6272 --- just words for now

	section .text2
	align 1

	global _compressed_altitude

_compressed_altitude   ; (long *altitude)

	pshm k
	tpd
	tbyk
	ldy  # altitab

	clrd               ; tentative return 0
	xgex
	lde  0,x
	beq  L11           ; 0 ... 65535 meters is good
	bmi  L13           ; negative altitude, return 0
	ldd  # 6145        ; over 65535 meters,
	bra  L13           ; return with code for 65.535 km
L11
	ldd  2,x           ; meters as word
	beq  L13           ; zero in, zero out
L12
	aiy  #+2           ; next checkpoint (first 2 are zero)
	cpd  2,y           ; last value is ~0, end safely
	bhi  L12           ; loop while our altitude is higher

	; (i * N) + (N * (meters - tab[i]) / (tab[i+1] - tab[i]))
 
	subd 0,y           ; our altitude - lower alt
	lde  2,y
	sube 0,y           ; higher alt - lower alt
	xgex
	fdiv               ; D / IX to IX. 0.16 fraction
	xgdy
	subd # altitab
	lsrd               ; offset to index
	tba
	clrb
	lsrd               ; index times 128 is MSpart
	xgdx               ; fraction to D, MSpart to IX
	lsrd               ; 7 msbits of fraction needed
	tab
	abx                ; merge
	xgdx
L13
	pulm k
	rts

	global _decompressed_altitude

_decompressed_altitude ; dword d_a(byte *ascii_cs)

	pshm k
	tpd
	tbyk
	ldy  # altitab

	xgex               ; ascii cs from *ix
	ldaa # 91
	ldab 0,x           ; 1st character
	mul
	addb 1,x           ; 2nd character
	adca # 0           ; always positive value
	clre               ; assume 0 meters
	subd # 92 * '!'    ; binary 'cs' into D
	ble  L23           ; zero in, zero out
	come               ; assume 65535 meters
	cpd  # 6145        ; ceiling code
	bhs  L23           ; if too high

	; (tab[i+1] - tab[i]) * (code % N) / N + tab[i]

	asld               ; A == code / 128, B == code % 128
	xgab
	aby                ; altitab + code / 128
	aby                ; twice, word offset

	clrb
	lsrd               ; as signed fraction
	lde  2,y
	sube 0,y           ; higher alt - lower alt
	lsre               ; 1.15 this too
	fmuls
	asld
	role               ; drop sign
	adde 0,y           ; add lower alt
L23
	ted
	clre               ; return as a dword
	pulm k
	rts                ; meters in D

	end

